/* $Id: oberechne.c,v 1.1 1999/05/22 13:10:43 fzk Exp fzk $ */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "oloid.h"

void
berechneolo (OPTIONS o) {

    BWINKEL w;
    double dw, fakt;
    int seg;
    int anzpos = 0;

    oi = 1;

    if (o.dw == 0.) {
	o.dw = 2. * M_PI / 60.;
    }

    /* A durchlaeuft mit Schrittweite dw (+- je nach Segment) die
       Werte PI bis 1/3*PI, 1/3*PI bis -1/3*PI, -1/3*PI bis PI.  Der
       Startwert PI wird um ein DELTA (= 1/1000) verflscht, um
       Vielfache von PI zu vermeiden. Fr jede Position werden 3
       Array-Positionen im Array olo belegt, die Koordinaten von A und
       B, sowie B' (= B gespiegelt um die u/v-Ebene).

       Nach der Berechnung erfolgt die Prfung, ob die Kante AB eine
       Lnge von sqrt(3) hat.  */

    dw = -o.dw;
    fakt = 1.;
    seg = 1;
    oi1 = oi;

    w = M_PI - dw;;
    while (TRUE) {
	/*Schleife wird mit break verlassen*/;
	if (w>M_PI_2 && w<3./2.*M_PI) {
	    fakt = 1.;
	} else if (w>1.22 && w<5.06) {
	    fakt = 0.8;
	} else {
	    fakt = 0.5;
	}

	/*
	  fprintf (stderr, "Positionen von A=%d w=%5.2f fakt=%5.2f\n", ++anzpos, w, fakt);
	*/

	w += dw * fakt;

	if (seg ==1) {
fprintf (stderr, "seg==%d w=%f dw=%f\n", seg, GWINKEL(w), GWINKEL(dw));
	    if (w < (1./3.*M_PI)) {
		w = 1./3.*M_PI;
		seg = 2;
		oi2 = oi;
	    }
   	}

	berechneolopos(w);

	if (seg == 2) {
	    break;
	}
    }

fprintf (stderr, "Anzahl berechneter Punkte oi = %d\n", oi);

    if (rechnung_nicht_ok) {

	printf ("Achtung: Probe zeigt Rechenfehler, weiter mit RETURN\n");
	warten (10000);
    }
    printolo(o);

}

void
berechneolopos(BWINKEL w) {
    RPUNKT zwi;

    /*
    ** Punkt A am Einheitskreis in Ma, in der u/v-Ebene
    */
    O(oi,u) = -1./2. + cos(w);
    O(oi,v) = sin(w);
    O(oi,w) = 0.;
    oi++;

    /*
    ** Punkt T. T und der Fusspunkt A' von A sind invers in Bezug auf
    ** den Einheitskreis in Ma, in der u/v-Ebene
    */
    zwi.u = -1./2. + 1./cos(w);
    zwi.v = 0.;
    zwi.w = 0.;
    if (zwi.u < -9999) {zwi.u = -9999;}
    if (zwi.u >  9999) {zwi.u =  9999;}
    if (zwi.u > 0. && zwi.u < 1.5) {zwi.u = 1.5001;}

    /*
    ** von T den Beruehrungspunkt B der Tangente am Einheitskreis im Mb,
    ** in der u/w-Ebene berechnen. Der Fusspunkt B' und T sind invers
    ** in Bezug auf diesen Einheitskreis.
    */
    O(oi,u) = (1. + 1./2.*zwi.u - 1./4.) / (zwi.u - 1./2.);
    O(oi,v) = 0.;
    O(oi,w) = sin(acos(1./2. - O(oi,u)));
    oi++;

    /*
    ** Probe: Distanz A-B mu sqrt(3) sein
    */
    if ((sqrt(3.) - sqrt (pow (O(oi-2,u)-O(oi-1,u), 2.) +
                          pow (O(oi-2,v)-O(oi-1,v), 2.) +
                          pow (O(oi-2,w)-O(oi-1,w), 2.))) > DELTA) {
	printf ("Distanz A-B bei %7.3f ist %f soll %f\n",
		GWINKEL(w),
		sqrt (pow (O(oi-2,u)-O(oi-1,u), 2.) +
		      pow (O(oi-2,v)-O(oi-1,v), 2.) +
		      pow (O(oi-2,w)-O(oi-1,w), 2.)), sqrt(3.));
	rechnung_nicht_ok = TRUE;
    }

    /*
    ** den Punkt B um die u/v-Ebene spiegelen
    */
    O(oi,u) =  O(oi-1,u);
    O(oi,v) =  O(oi-1,v);
    O(oi,w) = -O(oi-1,w);
    oi++;

    if (oi > 4) {
    /* A um die u/w-Ebene spiegeln */
    O(oi,u) =  O(oi-3,u);
    O(oi,v) = -O(oi-3,v);
    O(oi,w) =  O(oi-3,w);
    oi++;

    /* B und B' kopieren */
    O(oi,u) =  O(oi-3,u);
    O(oi,v) =  O(oi-3,v);
    O(oi,w) =  O(oi-3,w);
    oi++;

    O(oi,u) =  O(oi-3,u);
    O(oi,v) =  O(oi-3,v);
    O(oi,w) =  O(oi-3,w);
    oi++;
    }
}

#define PRINT3D(f,n) fprintf (f, "%f %f %f\n", olo.e[n-1].u, \
                                               olo.e[n-1].v, \
					       olo.e[n-1].w)
#define PRINTSEGS(f,k) (fprintf (f, "%f %f %f\n%f %f %f\n", \
        olo.e[k-1].u, \
        olo.e[k-1].v, \
        olo.e[k-1].w, \
        olo.e[k].u, \
	olo.e[k].v, \
	olo.e[k].w))

void
printolo(OPTIONS o) {
    int i;
    FILE *f3d;
    FILE *fsegs;

    if (! o.print) {
	return;
    }

    f3d   = fopen (FILE3D, "w");
    fsegs = fopen (FILESEGS, "w");

	fprintf (f3d,   "# Positionen des Oloids, jeweils A, B, B'\n");
	fprintf (fsegs, "# Segmente des Oloids, jeweils A-B und A-B'\n");

	for (i=1; i<=oi; i++) {
	    PRINT3D (f3d, i);
	}
	/*
	** die Erzeugende Strecke des Oloids ausgeben
	*/
	for (i=1; i<=oi; i+=2) {
	    PRINTSEGS (fsegs,i);
	}

	fprintf (f3d,   "\n");
	fprintf (fsegs, "\n\n");
    
    fclose (f3d);
    fclose (fsegs);
}
