/* $Id: oloid.h,v 1.1 1999/05/22 13:10:52 fzk Exp fzk $ */

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#define DELTA 0.001

#define FILE2D(i1, i2) "daten2d"#i1#i2".dat"
#define FILE3D         "daten3d.dat"
#define FILESEGS       "datensegs.dat"
#define FILEOLOID      "datenoloid.dat"

#define MAXOLOID 3000
#define MAXSEGMENTS 3000

typedef double CKOORD;            /* eine kartesische Koordinate */
typedef double BWINKEL;           /* ein Winkel im Bogenmass */
#define GWINKEL(b) (double)((b)*180./M_PI)    /* Bogenmass in Grad umrechnen */
#define BWINKEL(g) (double)((g)/180.*M_PI)    /* Grad in Bogenmass umrechnen */

#define O(n,i) (olo.e[n-1].i)     /* Oloidpunkte */
#define Oz(n,i) (oloz.e[n-1].i)   /* Oloidpunkte projeziert */

typedef struct segs {
    char von;
    char nach;
} KANTE;

typedef enum boolean {
    FALSE = 0,
    TRUE = 1,
    nein = FALSE,
    ja = TRUE
} BOOLEAN;

typedef struct epunkt {      /* ein Punkt in der Ebene */
    CKOORD x;
    CKOORD y;
} EPUNKT;

typedef struct rpunkt {      /* ein Punkt im Raum */
    CKOORD u;
    CKOORD v;
    CKOORD w;
} RPUNKT;

typedef struct oloid {       /* die Enden A und B der Erzeugenden des Oloids */
    RPUNKT e[MAXOLOID];
} OLOID;

typedef struct options {     /* Aufrufparameter */
    unsigned int seite;      /* -b Breite des Fensters in Pixeln */
    BWINKEL      dw;         /* -w Winkel, um den sich 2 Pos. unterscheiden */
    BOOLEAN      print;      /* -p print, gibt Koordinaten der Eckpunkte aus */
} OPTIONS;

void berechneolo    (OPTIONS o);
void berechneolopos (BWINKEL winkel);
void zeichneolo     (OPTIONS *o);
void printolo       (OPTIONS o);
int  projeziereolo  (OPTIONS o, BWINKEL wx, BWINKEL wy, BWINKEL wz,
		     XSegment *p);
void freeolo        (OLOID *wg);
void getoptions     (int argc, char **argv, OPTIONS *o);
void ident          (void);
void usage          (void);
void control        (void);
void warten         (int sec);

#ifdef DEFINECONSTANTS
/*
** Oloid: berechneten Punkte A und B
*/
OLOID olo;
int oi;
int oi1, oi2, oi3, oi4, oi5;

BOOLEAN rechnung_nicht_ok = FALSE;
#else
extern OLOID olo;
extern int oi;
extern int oi1, oi2, oi3, oi4, oi5;

extern BOOLEAN rechnung_nicht_ok;
#endif
