/* $Id: oprojeziere.c,v 1.1 1999/05/22 13:11:14 fzk Exp fzk $ */

/* Projektion der Raumpunkte auf die Zeichenebene */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <math.h>
#include "oloid.h"

/*
** Aufriss (ohne Bercksichtigung der Koordinate v)
*/
#define AUF(a,b) s[i].x1 = (short)(dx + fx *  Oz(a,u)); \
                 s[i].y1 = (short)(dy + fy * -Oz(a,w)); \
                 s[i].x2 = (short)(dx + fx *  Oz(b,u)); \
                 s[i].y2 = (short)(dy + fy * -Oz(b,w)); \
                 i++; \
                 if (i >= MAXSEGMENTS) { \
                    fprintf (stderr, "Wert von MAXSEGMENTS ist zu klein\n"); \
                    exit (1); \
                 } \
if ((Oz(a,u) == 0. && Oz(a,v) == 0. && Oz(a,w) == 0.) || \
    (Oz(b,u) == 0. && Oz(b,v) == 0. && Oz(b,w) == 0.)) { \
    fprintf (stderr, "Verbindung zum 0-Punkt k=%d Segment i=%d\n", k, i); \
    exit (1); \
}


/* Die Koordinaten in olo[] werden um wu, wv und ww gedreht, nach
   oloz[] geschrieben und dann mittels macro AUF() auf die
   Darstellungsebene (u/w-Ebene) projeziert.  Returnwert ist die
   Anzahl der berechneten X-Segments */
int
projeziereolo (OPTIONS o,
	    BWINKEL wu, BWINKEL wv, BWINKEL ww,
	    XSegment *s)
{
    OLOID oloz;
    double fx, fy, dx, dy;
    int i = 0;
    int j;
    int k;

    dx = o.seite / 2.;
    dy = o.seite / 2.;
    fx = fy = o.seite / 4.;

    /*
    ** Zuerst Drehung um die x-Achse um den Winkel wu berechnen
    */
    for (j=1; j<=oi; j++) {
	Oz(j,u) = O(j,u);
	Oz(j,v) = O(j,v)*  cos(wu) + O(j,w)*sin(wu);
	Oz(j,w) = O(j,v)* -sin(wu) + O(j,w)*cos(wu);
    }

    /*
    ** Dann Drehung um die y-Achse um den Winkel wv
    */
    for (j=1; j<=oi; j++) {
	RPUNKT zwi;

	zwi.u = Oz(j,u);
	zwi.v = Oz(j,v);
	zwi.w = Oz(j,w);
	Oz(j,u) = zwi.u*  cos(wv) + zwi.w* sin(wv);
	Oz(j,v) = zwi.v;
	Oz(j,w) = zwi.u* -sin(wv) + zwi.w* cos(wv);
    }

    /*
    ** Schliesslich Drehung um die z-Achse um den Winkel ww
    */
    for (j=1; j<=oi; j++) {
	RPUNKT zwi;

	zwi.u = Oz(j,u);
	zwi.v = Oz(j,v);
	zwi.w = Oz(j,w);
	Oz(j,u) = zwi.u*  cos(ww) + zwi.v* sin(ww);
	Oz(j,v) = zwi.u* -sin(ww) + zwi.v* cos(ww);
	Oz(j,w) = zwi.w;
    }

    /*
    ** Erzeugende des Oloids
    */
    for (k=3; k<=(oi); k+=3) {
	if (k-1 <= oi) {AUF (k-2, k-1);}
	if (k   <= oi) {AUF (k-2, k);}
    }
    /*
    ** Kreisboegen des Oloids
    */
    for (k=6; k<=oi; k+=6) {
	if (k-1 <= oi) {AUF (k-4, k-1);}
	if (k   <= oi) {AUF (k-3, k);}
    }
    AUF (1, 4);
    for (k=10; k<oi; k+=6) {
	AUF (k-6, k);
    }
    for (k=7; k<oi; k+=6) {
	AUF (k-6, k);
    }

/*     AUF (oi1, oi1+1); */
/*     AUF (oi2, oi2+1); */
/*     AUF (oi4, oi4+1); */
/*     AUF (oi5, oi5+1); */

    return i;
}
