/* $Id: ozeichne.c,v 1.1 1999/05/22 13:11:20 fzk Exp fzk $ */

/* Zeichnen des Oloids mit X-Windows */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include "oloid.h"

#define DRAWSEGS \
        XDrawSegments (display, window, gcxor1, s, count);

#define REDRAW \
	DRAWSEGS \
	count = projeziereolo (*o, wu, wv, ww, s); \
	DRAWSEGS
void
zeichneolo (OPTIONS  *o) {
    Display *display;
    int     screen;
    Window  window;
    XEvent  event;
    unsigned long mask;

    unsigned int width;
    unsigned int height;
    unsigned int border_width;
    int          x, y;

    GC        gcxor1;
    XGCValues gcvalues;

    int    firsttime = TRUE;
    BWINKEL wu, wv, ww;
    int mx, my;
    XSegment s[MAXSEGMENTS];

    BOOLEAN  halt = FALSE;

    struct timeval waittime;
    long wait_usec;
    long l, z;
    int count = 0;
    static BOOLEAN turnu = TRUE;
    static BOOLEAN turnv = TRUE;
    static BOOLEAN turnw = TRUE;

    l = z = 0;
    wu = wv = ww = DELTA;
    mx = my = 0;

    border_width = 10;
    x = y = 0;

    if ((display = XOpenDisplay (getenv("DISPLAY"))) == NULL) {
	fprintf (stderr, "Cannot open Display\n");
	exit (1);
    }

    screen = DefaultScreen (display);

    if ((*o).seite == 0) {
	width = DisplayWidth (display, screen) / 2;
	/* height = DisplayHeight (display, screen) / 2; */
	height = width;
	(*o).seite = width;
    }
    else {
	width = height = (*o).seite;
    }

    window = XCreateSimpleWindow (display, RootWindow (display, screen),
				  x, y, width, height, border_width,
				  BlackPixel (display, screen),
				  WhitePixel (display, screen));

    mask = GCForeground | GCFunction | GCLineWidth;
    gcvalues.function = GXxor;
    gcvalues.foreground = BlackPixel (display, screen) ^
	                              WhitePixel (display, screen);
    gcvalues.line_width = 1;
    gcxor1 = XCreateGC (display, window, mask, &gcvalues);

    XSetStandardProperties (display, window, "Das Oloid",
			    "Oloid", 0, NULL, 0, NULL);

    mask = ExposureMask |
	   KeyPressMask;

    XSelectInput (display, window, mask);

    XMapWindow (display, window);

    waittime.tv_sec = 0;
    waittime.tv_usec = 100000;

    while (TRUE) {
	/* XNextEvent (display, &event); */
	/* XWindowEvent (display, window, mask, &event); */
	if (XCheckWindowEvent (display, window, mask, &event)) {
	    /* fprintf (stderr, "event.type=%d\n",  event.type); */

	    switch (event.type) {
		char *ksstring;

	    case Expose:
/* 		fprintf (stderr, "Expose "); */
/* 		while  (XCheckTypedEvent(display, Expose, &event)) { */
/* 		    fprintf  (stderr, "."); */
/* 		} */
/* 		fprintf (stderr, "\n"); */
		XClearWindow (display, window);
		DRAWSEGS
		break;

	    case KeyPress:
		ksstring = XKeysymToString (XKeycodeToKeysym (display, event.xkey.keycode, 0));
		/* fprintf (stderr, "keypressed keycode=%d keysym=<%s>",
                            event.xkey.keycode, ksstring); */
	      
		if (! strcmp ("plus", ksstring)) {
/* 		    fprintf (stderr, " + "); */
		    if (waittime.tv_usec == 0) {
			waittime.tv_usec = 1;
		    }
		    else {
			waittime.tv_usec = waittime.tv_usec * 2;
		    }
		    if (waittime.tv_usec > 10000000) {
			waittime.tv_usec = 10000000;
		    }
		}
		else if (! strcmp ("minus", ksstring)) {
/* 		    fprintf (stderr, " - "); */
		    waittime.tv_usec = waittime.tv_usec / 2;
		}
		else if (! strcmp ("q", ksstring)) {
/* 		    fprintf (stderr, " q\n"); */
		    XCloseDisplay (display);
		    exit (0);
		}
		else if (! strcmp ("s", ksstring)) {
/* 		    fprintf (stderr, " s "); */
		    halt = ! halt;
		}
		else if (! strcmp ("u", ksstring)) {
/* 		    fprintf (stderr, " u "); */
		    turnu = ! turnu;
		    REDRAW
		}
		else if (! strcmp ("v", ksstring)) {
/* 		    fprintf (stderr, " v "); */
		    turnv = ! turnv;
		    REDRAW
	        }
		else if (! strcmp ("w", ksstring)) {
/* 		    fprintf (stderr, " w "); */
		    turnw = ! turnw;
		    REDRAW
		}
		else if (! strcmp ("0", ksstring)) {
/* 		    fprintf (stderr, " 0 "); */
		    wu = wv = ww = DELTA;
		    turnu = FALSE;
		    turnv = turnw = FALSE;
		    REDRAW
	        }
/* 		fprintf (stderr, " wait=%d wu=%5.3f wv=%5.3f ww=%5.3f\n", */
/* 			 (int)waittime.tv_usec, wu, wv, ww); */
		break;
	    }
	}

	if (! halt) {

	    /* Da das Oloid in sich unbeweglich ist, wird es gedreht mit
	    ** dem Tasten u, v, w wird der Ansto in die jeweilige
	    ** Richtung gegeben oder widerrufen
	    */
	    if (turnu) {
		wu = wu > 2*M_PI ? DELTA : wu + M_PI/30.;
	    }
	    if (turnv) {
		wv = wv > 2*M_PI ? DELTA : wv + M_PI/30.;
	    }
	    if (turnw) {
		ww = ww > 2*M_PI ? DELTA : ww + M_PI/30.;
	    }

	    if (! firsttime) {
		/* aktuelle Zeichnung lschen */
		DRAWSEGS
		firsttime = FALSE;
	    }

		count = projeziereolo (*o, wu, wv, ww, s);

		DRAWSEGS

	    wait_usec = waittime.tv_usec;
	    select (0, NULL, NULL, NULL, &waittime); 
	    waittime.tv_usec = wait_usec;

	    if (firsttime) {
		/* sleep (3); */
		firsttime = FALSE;
	    }
	}
    }
}
